namespace ChoiceProj.Samples.MyModule
{
    public static class Program
    {
        public static void Main()
        {
            // Creating both choices 
            ChoiceProj.MyModule.Lunch myLunch = new ChoiceProj.MyModule.Lunch();
            myLunch.Item = "Chicken";
            myLunch.Fries = true;

            ChoiceProj.MyModule.Dinner myDinner = new ChoiceProj.MyModule.Dinner();
            myDinner.Entry = "Fish";
            myDinner.Drinks = 2;

            // Creating Order
            ChoiceProj.MyModule.Order myOrder = new ChoiceProj.MyModule.Order();

            // Selecting lunch
            myOrder.One = myLunch;

            switch (myOrder.Selected)
            {
                case ChoiceProj.MyModule.Order.Id.OneChosen:
                    System.Console.WriteLine("Enjoy your lunch.");
                    break;
                case ChoiceProj.MyModule.Order.Id.TwoChosen:
                    System.Console.WriteLine("Enjoy your dinner.");
                    break;
                case ChoiceProj.MyModule.Order.Id.Unselected:
                    System.Console.WriteLine("No order items selected. Nothing to encode.");
                    return;
            }

            // encoding/decoding/printing
            ChoiceProj.BerCodec codec = new ChoiceProj.BerCodec();

            byte[] ber = codec.Encode(myOrder);
            Oss.Asn1.ValueNotationFormatter.Print(ber, ber.Length, System.Console.Out);
            // output A00C8007 43686963 6B656E81 01FF

            codec.Decode(ber, myOrder);
            Oss.Asn1.ValueNotationFormatter.Print(myOrder, System.Console.Out);
            // output 
            // value Order ::= one :
            // {
            //   item "Chicken",
            //   fries TRUE
            // } 
        }
    }
}
